//---------------------------------------------------------------------------
// DigitBox v1.1
//
// This is a C++Builder component
// by Ylian Saint-Hilaire
// http://kairos.dsa.uqam.ca/software
//
// This component emulates the digits in minesweeper
//---------------------------------------------------------------------------
#ifndef DigitBoxH
#define DigitBoxH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
//---------------------------------------------------------------------------
class TDigitBox : public TCustomControl
{
private:
	MESSAGE void __fastcall WMSize (TWMSize &Message);
	MESSAGE void __fastcall WMTimer(TWMTimer &Message);

protected:
    TTimer *Timer;
    TColor BoxColor1;
	TColor BoxColor2;
	unsigned int delay;
   	unsigned int digits;
	unsigned long value;
	unsigned long target;
	TNotifyEvent FOnValueC;
   	TNotifyEvent FOnTargetC;
	TNotifyEvent FOnTargetR;
    __fastcall void Paint(void);
	__fastcall void DoPaint(void);
	__fastcall void setColor1(TColor C);
	__fastcall void setColor2(TColor C);
	__fastcall void setDelay(unsigned int D);
   	__fastcall void setValue(unsigned long V);
   	__fastcall void setDigits(unsigned int V);
	__fastcall void setTarget(unsigned long T);
	__fastcall void TimerExpired(TObject *Sender);
    __fastcall void PaintAxe(TPoint Point,char n,BOOL c);
    __fastcall void PaintDigit(const TPoint Point,const char number);

public:
	__fastcall TDigitBox(TComponent* Owner);
	__fastcall ~TDigitBox();
    __fastcall void inc(unsigned long V=1);
    __fastcall void dec(unsigned long V=1);

__published:
	__property TColor Color1        ={read=BoxColor1, write=setColor1};
	__property TColor Color2        ={read=BoxColor2, write=setColor2};
	__property unsigned int Digits  ={read=digits   , write=setDigits};
	__property unsigned int Delay   ={read=delay	, write=setDelay };
	__property unsigned long Value  ={read=value    , write=setValue };
	__property unsigned long Target ={read=target	, write=setTarget};
   	__property TNotifyEvent OnValueChange  = {read=FOnValueC , write=FOnValueC };
   	__property TNotifyEvent OnTargetReach  = {read=FOnTargetR, write=FOnTargetR};
   	__property TNotifyEvent OnTargetChange = {read=FOnTargetC, write=FOnTargetC};

BEGIN_MESSAGE_MAP
	MESSAGE_HANDLER(WM_SIZE, TWMSize , WMSize);
END_MESSAGE_MAP(TCustomControl);

};
//---------------------------------------------------------------------------
#endif
