// JDBGrid Version 1.0.0
// Author: Jason Ward
// cguru@gte.net
// 5/07/97
//..........................................................................
// A DBGrid component that has the OnMouseDown event exposed and a new event
// called OnTitleSelect. These events are usefull for detecting whether the
// Title Column has been Clicked for doing Sorts etc.
//..........................................................................
// To use, treat the JDBGrid component exactly like the DBGrid component.
// The only difference is 2 new events.
// The OnMouseDown event is exactly the same as in the BCB help files.
// The new event is OnTitleSelect(TObject *Sender, int pick) and is triggered
// by clicking on a JDBGrid title coloumn. pick contains the selected column
// number, with 0 being the leftmost column.
// Thats all Folks....
//..........................................................................
// This component is Copyright  1997 by Jason Ward, Sumner WA.
// Use this component freely.
// This is my way of giving back to the programming community.
// I'd welcome any comments or suggestions for improvements you may have,
// and if you find this component useful, drop me a note.
// Most of all, Enjoy. . .
//
//---------------------------------------------------------------------------
// History
// 5/07/97	New
#pragma link "Grids"
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "JDBGrid.h"
//---------------------------------------------------------------------------
static inline JDBGrid *ValidCtrCheck()
{
	return new JDBGrid(NULL);
}
//---------------------------------------------------------------------------
__fastcall JDBGrid::JDBGrid(TComponent* Owner)
	: TDBGrid(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall JDBGrid::MouseDown(TMouseButton Button, TShiftState Shift, int x, int y)
{
TGridCoord coord;
	TCustomDBGrid::MouseDown(Button, Shift, x, y);
    coord = TCustomGrid::MouseCoord(x,y);
	if(FOnMouseDown)
    	FOnMouseDown(this, Button, Shift, x, y);
	if(FOnTitleSelect && coord.Y == 0 && this->Options.Contains(dgTitles))
    	FOnTitleSelect(this, coord.X-1);
}
//---------------------------------------------------------------------------
namespace Jdbgrid
{
	void __fastcall Register()
	{
		TComponentClass classes[1] = {__classid(JDBGrid)};
		RegisterComponents("Jason", classes, 0);
	}
}
//---------------------------------------------------------------------------

