//----------------------------------------------------------------------------
// jpeg.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: jpeg.pas
//----------------------------------------------------------------------------
#ifndef jpegHPP
#define jpegHPP
//----------------------------------------------------------------------------
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <Windows.hpp>
#include <Classes.hpp>
#include <jpeglib.hpp>
#include <System.hpp>
namespace Jpeg
{
//-- type declarations -------------------------------------------------------
class __declspec(delphiclass) TJPEGBase;
class __declspec(pascalimplementation) TJPEGBase : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	Jpeglib::jpeg_common_struct *JPEGObject;
	bool FInAbort;
	bool FInProgress;
	bool FAbortRequested;
	Classes::TNotifyEvent FOnProgressReport;
	long __fastcall GetWarnings(void);
	int __fastcall GetTraceLevel(void);
	int __fastcall GetPercentDone(void);
	void __fastcall SetTraceLevel(int p0);
	virtual void __fastcall CreateJPEGObject(Jpeglib::jpeg_error_mgr_ptr p0) = 0;
	
protected:
	virtual void __fastcall Error(void);
	virtual void __fastcall Warning(int p0);
	virtual void __fastcall DoProgress(void);
	long __fastcall Round4(long p0);
	
public:
	__fastcall virtual TJPEGBase(Classes::TComponent* p0);
	__fastcall virtual ~TJPEGBase(void);
	virtual void __fastcall Abort(void);
	__property long Warnings = {read=GetWarnings, nodefault};
	__property int Trace_Level = {read=GetTraceLevel, write=SetTraceLevel, nodefault};
	__property int PercentDone = {read=GetPercentDone, nodefault};
	__property Classes::TNotifyEvent OnProgessReport = {read=FOnProgressReport, write=FOnProgressReport
		};
};

class __declspec(delphiclass) TJPEGCompressor;
class __declspec(pascalimplementation) TJPEGCompressor : public TJPEGBase
{
	typedef TJPEGBase inherited;
	
private:
	System::AnsiString FComment;
	bool FProgressiveJPEG;
	bool FWriteAllTables;
	int FQuality;
	bool FGrayscaleOutput;
	Classes::TNotifyEvent FOnWriteMarkers;
	Jpeglib::JOCTET_PTR __fastcall GetNextOut(void);
	int __fastcall GetFreeIn(void);
	void __fastcall SetNextOut(Jpeglib::JOCTET_PTR p0);
	void __fastcall SetFreeIn(int p0);
	void __fastcall SetQuality(int p0);
	virtual void __fastcall CreateJPEGObject(Jpeglib::jpeg_error_mgr_ptr p0);
	
protected:
	Jpeglib::jpeg_compress_struct cinfo;
	virtual void __fastcall InitDestination(void) = 0;
	virtual bool __fastcall EmptyOutputBuffer(void) = 0;
	virtual void __fastcall TermDestination(void) = 0;
	void __fastcall SetColorSpace(Jpeglib::J_COLOR_SPACE p0);
	void __fastcall WriteDIBitmap(const tagBITMAPINFO &jpeg_, char * p1);
	void __fastcall WriteBitmap(Graphics::TBitmap* p0);
	void __fastcall WriteMetaFile(Graphics::TMetafile* p0, long p1, long p2);
	__property Jpeglib::JOCTET_PTR next_out = {read=GetNextOut, write=SetNextOut, nodefault};
	__property int free_in = {read=GetFreeIn, write=SetFreeIn, nodefault};
	__property int InputComponents = {read=cinfo.input_components, nodefault};
	__property Cardinal ImageWidth = {read=cinfo.image_width, write=cinfo.image_width, nodefault};
	__property Cardinal ImageHeight = {read=cinfo.image_height, write=cinfo.image_height, nodefault};
	
public:
	__fastcall virtual TJPEGCompressor(Classes::TComponent* p0);
	__fastcall virtual ~TJPEGCompressor(void);
	void __fastcall AddQuantTable(int p0, Jpeglib::uint_ptr const p1, int p2, bool p3);
	void __fastcall WriteMarker(int p0, const void *p1, int p2);
	__property double InputGamma = {read=cinfo.input_gamma, write=cinfo.input_gamma};
	__property int DataPrecision = {read=cinfo.data_precision, write=cinfo.data_precision, nodefault};
	__property Jpeglib::J_COLOR_SPACE OutputColorSpace = {read=cinfo.jpeg_color_space, nodefault};
	__property bool GrayscaleOutput = {read=FGrayscaleOutput, write=FGrayscaleOutput, nodefault};
	__property System::AnsiString Comment = {read=FComment, write=FComment, nodefault};
	__property int Quality = {read=FQuality, write=SetQuality, default=75};
	__property bool ProgressiveJPEG = {read=FProgressiveJPEG, write=FProgressiveJPEG, nodefault};
	__property Jpeglib::J_DCT_METHOD DCTMethod = {read=cinfo.dct_method, write=cinfo.dct_method, nodefault
		};
	__property bool OptimizeCoding = {read=cinfo.optimize_coding, write=cinfo.optimize_coding, nodefault
		};
	__property Cardinal RestartInterval = {read=cinfo.restart_interval, write=cinfo.restart_interval, nodefault
		};
	__property int RestartInRows = {read=cinfo.restart_in_rows, write=cinfo.restart_in_rows, nodefault}
		;
	__property int SmoothingFactor = {read=cinfo.smoothing_factor, write=cinfo.smoothing_factor, nodefault
		};
	__property bool WriteJFIFHeader = {read=cinfo.write_JFIF_header, write=cinfo.write_JFIF_header, nodefault
		};
	__property Byte DensityUnit = {read=cinfo.density_unit, write=cinfo.density_unit, nodefault};
	__property Word X_Density = {read=cinfo.X_density, write=cinfo.X_density, nodefault};
	__property Word Y_Density = {read=cinfo.Y_density, write=cinfo.Y_density, nodefault};
	__property bool WriteAdobeMarker = {read=cinfo.write_Adobe_marker, write=cinfo.write_Adobe_marker, 
		nodefault};
	__property bool WriteAllTables = {read=FWriteAllTables, write=FWriteAllTables, default=1};
	__property Classes::TNotifyEvent OnWriteMarkers = {read=FOnWriteMarkers, write=FOnWriteMarkers};
};

typedef void __fastcall (__closure *TJPEGCommentEvent)(TJPEGBase* sender, char * comment);

typedef void __fastcall (__closure *TJPEGMarkerEvent)(TJPEGBase* sender, int Marker, bool &done);

enum TJPEGOutputType { jp24bit, jp8bit, jp4bit, jpGrayscale };

class __declspec(delphiclass) TJPEGDecompressor;
class __declspec(pascalimplementation) TJPEGDecompressor : public TJPEGBase
{
	typedef TJPEGBase inherited;
	
private:
	TJPEGCommentEvent FOnJPEGComment;
	J_DCT_METHOD FDCT_METHOD;
	bool FDoFancyUpSampling;
	bool FDoBlockSmoothing;
	bool FGrayScaleOutput;
	bool FTwoPassQuantize;
	J_DITHER_MODE FDitherMode;
	TJPEGMarkerEvent FOnJPEGMarker;
	virtual void __fastcall CreateJPEGObject(Jpeglib::jpeg_error_mgr_ptr p0);
	Jpeglib::JOCTET_PTR __fastcall GetNextInputByte(void);
	int __fastcall GetBytesInBuffer(void);
	void __fastcall SetNextInputByte(Jpeglib::JOCTET_PTR p0);
	void __fastcall SetBytesInBuffer(int p0);
	bool __fastcall HandleJPEGComment(void);
	bool __fastcall HandleAPPMarker(void);
	
protected:
	Jpeglib::jpeg_decompress_struct cinfo;
	virtual void __fastcall InitSource(void) = 0;
	virtual bool __fastcall FillInputBuffer(void) = 0;
	virtual void __fastcall SkipInputBytes(long p0) = 0;
	virtual bool __fastcall ResyncToRestart(int p0) = 0;
	virtual void __fastcall TermSource(void) = 0;
	virtual bool __fastcall DoJPEGComment(char * p0);
	void __fastcall ReadDIBitmap(tagBITMAPINFO &jpeg_, TJPEGOutputType p1, void * p2);
	Graphics::TBitmap* __fastcall ReadBitmap(void);
	void __fastcall ReadWinBitmap(HBITMAP &p0, HPALETTE &p1);
	virtual void __fastcall ReadHeader(void);
	__property Jpeglib::JOCTET_PTR NextInputByte = {read=GetNextInputByte, write=SetNextInputByte, nodefault
		};
	__property int BytesInBuffer = {read=GetBytesInBuffer, write=SetBytesInBuffer, nodefault};
	__property Jpeglib::J_COLOR_SPACE OutputColorSpace = {read=cinfo.out_color_space, nodefault};
	__property Cardinal ScaleNum = {read=cinfo.scale_num, write=cinfo.scale_num, nodefault};
	__property Cardinal ScaleDenom = {read=cinfo.scale_denom, write=cinfo.scale_denom, nodefault};
	__property double OutputGamma = {read=cinfo.output_gamma, write=cinfo.output_gamma};
	__property bool QuantizeColors = {read=cinfo.quantize_colors, write=cinfo.quantize_colors, nodefault
		};
	__property int NumColorsDesired = {read=cinfo.desired_number_of_colors, write=cinfo.desired_number_of_colors
		, nodefault};
	__property Jpeglib::JSAMPARRAY ColorMap = {read=cinfo.colormap, write=cinfo.colormap, nodefault};
	__property int ActualColorsInMap = {read=cinfo.actual_number_of_colors, write=cinfo.actual_number_of_colors
		, nodefault};
	
public:
	__fastcall virtual TJPEGDecompressor(Classes::TComponent* p0);
	__fastcall virtual ~TJPEGDecompressor(void);
	long __fastcall GetBitmapInfoSize(TJPEGOutputType p0);
	long __fastcall GetDIBitsSize(TJPEGOutputType p0);
	Byte __fastcall GetByte(void);
	__property TJPEGCommentEvent OnJPEGComment = {read=FOnJPEGComment, write=FOnJPEGComment};
	__property TJPEGMarkerEvent OnJPEGMarker = {read=FOnJPEGMarker, write=FOnJPEGMarker};
	__property bool GrayScaleOutput = {read=FGrayScaleOutput, write=FGrayScaleOutput, nodefault};
	__property Cardinal Width = {read=cinfo.image_width, nodefault};
	__property Cardinal Height = {read=cinfo.image_height, nodefault};
	__property int NumComponents = {read=cinfo.num_components, nodefault};
	__property Jpeglib::J_COLOR_SPACE ColorSpace = {read=cinfo.jpeg_color_space, nodefault};
	__property bool JFIFMarkerPresent = {read=cinfo.saw_JFIF_marker, nodefault};
	__property Byte DensityUnit = {read=cinfo.density_unit, nodefault};
	__property Word X_Density = {read=cinfo.X_density, nodefault};
	__property Word Y_Density = {read=cinfo.Y_density, nodefault};
	__property bool AdobeMarkerPresent = {read=cinfo.saw_Adobe_marker, nodefault};
	__property Byte AdobeTransform = {read=cinfo.Adobe_transform, nodefault};
	__property bool TwoPassQuantize = {read=FTwoPassQuantize, write=FTwoPassQuantize, default=1};
	__property Jpeglib::J_DITHER_MODE DitherMode = {read=FDitherMode, write=FDitherMode, default=2};
	__property Jpeglib::J_DCT_METHOD DCTMethod = {read=FDCT_METHOD, write=FDCT_METHOD, default=0};
	__property bool DoFancyUpSampling = {read=FDoFancyUpSampling, write=FDoFancyUpSampling, default=1};
		
	__property bool DoBlockSmoothing = {read=FDoBlockSmoothing, write=FDoBlockSmoothing, default=1};
	__property bool Enable1PassQuant = {read=cinfo.enable_1pass_quant, write=cinfo.enable_1pass_quant, 
		nodefault};
	__property bool EnableExternalQuant = {read=cinfo.enable_external_quant, write=cinfo.enable_external_quant
		, nodefault};
	__property bool Enable2PassQuant = {read=cinfo.enable_2pass_quant, write=cinfo.enable_2pass_quant, 
		nodefault};
	__property Cardinal OutputHeight = {read=cinfo.output_height, nodefault};
	__property Cardinal OutputWidth = {read=cinfo.output_width, nodefault};
};

class __declspec(delphiclass) TJPEGStreamCompressor;
class __declspec(pascalimplementation) TJPEGStreamCompressor : public TJPEGCompressor
{
	typedef TJPEGCompressor inherited;
	
private:
	Classes::TStream* FStream;
	void *FBuffer;
	int FBufSize;
	
protected:
	virtual void __fastcall InitDestination(void);
	virtual bool __fastcall EmptyOutputBuffer(void);
	virtual void __fastcall TermDestination(void);
	void __fastcall OpenStream(Classes::TStream* p0);
	void __fastcall CloseStream(void);
	
public:
	__fastcall virtual TJPEGStreamCompressor(Classes::TComponent* p0);
	__fastcall virtual ~TJPEGStreamCompressor(void);
	void __fastcall SavePictureToStream(Graphics::TPicture* p0, Classes::TStream* p1);
	void __fastcall SaveBitMapToStream(Graphics::TBitmap* p0, Classes::TStream* p1);
	void __fastcall SaveDIBitmapToStream(Classes::TStream* p0, const tagBITMAPINFO &jpeg_, char * p2);
	void __fastcall SaveMetaFileToStream(Graphics::TMetafile* p0, Classes::TStream* p1, long p2, long p3
		);
	__property int BufSize = {read=FBufSize, write=FBufSize, default=4096};
};

class __declspec(delphiclass) TJPEGStreamDecompressor;
class __declspec(pascalimplementation) TJPEGStreamDecompressor : public TJPEGDecompressor
{
	typedef TJPEGDecompressor inherited;
	
private:
	Classes::TStream* FStream;
	char *FBuffer;
	int FBufSize;
	
protected:
	virtual void __fastcall InitSource(void);
	virtual bool __fastcall FillInputBuffer(void);
	virtual void __fastcall SkipInputBytes(long p0);
	virtual bool __fastcall ResyncToRestart(int p0);
	virtual void __fastcall TermSource(void);
	
public:
	void __fastcall OpenStream(Classes::TStream* p0);
	void __fastcall CloseStream(void);
	__fastcall virtual TJPEGStreamDecompressor(Classes::TComponent* p0);
	__fastcall virtual ~TJPEGStreamDecompressor(void);
	void __fastcall ConvertToDIB(Classes::TStream* p0, Classes::TStream* p1, TJPEGOutputType p2);
	void __fastcall LoadPictureFromStream(Graphics::TPicture* p0, Classes::TStream* p1);
	Graphics::TBitmap* __fastcall ReadBitMapFromStream(Classes::TStream* p0);
	void __fastcall ReadDIBitmapFromStream(Classes::TStream* p0, tagBITMAPINFO &jpeg_, TJPEGOutputType 
		p2, int &p3);
	__property int BufSize = {read=FBufSize, write=FBufSize, default=4096};
};

class __declspec(delphiclass) TJPEGFileDecompressor;
class __declspec(pascalimplementation) TJPEGFileDecompressor : public TJPEGStreamDecompressor
{
	typedef TJPEGStreamDecompressor inherited;
	
public:
	void __fastcall LoadPictureFromFile(Graphics::TPicture* p0, const System::AnsiString p1);
	
__published:
	__property Warnings ;
	__property Trace_Level ;
	__property PercentDone ;
	__property GrayScaleOutput ;
	__property OnJPEGComment ;
	__property OnJPEGMarker ;
	__property TwoPassQuantize ;
	__property DitherMode ;
	__property DCTMethod ;
	__property DoFancyUpSampling ;
	__property DoBlockSmoothing ;
	__property OnProgessReport ;
public:
	/* TJPEGStreamDecompressor.create */ __fastcall virtual TJPEGFileDecompressor(Classes::TComponent* 
		p0) : Jpeg::TJPEGStreamDecompressor(p0) { }
	/* TJPEGStreamDecompressor.Destroy */ __fastcall virtual ~TJPEGFileDecompressor(void) { }
	
};

class __declspec(delphiclass) TJPEGFileCompressor;
class __declspec(pascalimplementation) TJPEGFileCompressor : public TJPEGStreamCompressor
{
	typedef TJPEGStreamCompressor inherited;
	
public:
	void __fastcall SavePictureToFile(Graphics::TPicture* p0, const System::AnsiString p1);
	
__published:
	__property Warnings ;
	__property Trace_Level ;
	__property PercentDone ;
	__property GrayscaleOutput ;
	__property Comment ;
	__property Quality ;
	__property InputGamma ;
	__property ProgressiveJPEG ;
	__property DCTMethod ;
	__property OptimizeCoding ;
	__property RestartInterval ;
	__property RestartInRows ;
	__property SmoothingFactor ;
	__property WriteJFIFHeader ;
	__property DensityUnit ;
	__property X_Density ;
	__property Y_Density ;
	__property WriteAllTables ;
	__property OnProgessReport ;
	__property OnWriteMarkers ;
public:
	/* TJPEGStreamCompressor.create */ __fastcall virtual TJPEGFileCompressor(Classes::TComponent* p0) : 
		Jpeg::TJPEGStreamCompressor(p0) { }
	/* TJPEGStreamCompressor.Destroy */ __fastcall virtual ~TJPEGFileCompressor(void) { }
	
};

class __declspec(delphiclass) TJPEGBitmap;
class __declspec(pascalimplementation) TJPEGBitmap : public Graphics::TBitmap
{
	typedef Graphics::TBitmap inherited;
	
private:
	bool FSaveAsBitmap;
	
public:
	virtual void __fastcall LoadFromStream(Classes::TStream* p0);
	virtual void __fastcall SaveToStream(Classes::TStream* p0);
	virtual void __fastcall SaveToFile(const System::AnsiString p0);
public:
	/* TBitmap.Create */ __fastcall virtual TJPEGBitmap(void) : Graphics::TBitmap() { }
	/* TBitmap.Destroy */ __fastcall virtual ~TJPEGBitmap(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define DefaultBufSize (Word)(4096)
#define DefaultQuality (Byte)(75)
extern bool UseIsIllegal;
extern Graphics::TBitmap* __fastcall MetaToBitmap(Graphics::TMetafile* p0, long p1, long p2);

}	/* namespace Jpeg */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Jpeg;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// jpeg
