// JResfix Version 1.5.0
// Author: Jason Ward
// cguru@gte.net
// 4/17/97
//..........................................................................
// A Component that will resize components on a form when it is run on a
// machine with different PixelsPerInch(Large or Small font) than was used for
// development.
//..........................................................................
// To use, place the JResFix component on your form.
// Set DesignFont to the Font you are compiling in, dmLargeFont or dmSmallFont
// In your Forms OnShow handler, call JResFix1->FixRes();
// Thats all Folks....
//..........................................................................
// This component is Copyright  1997 by Jason Ward, Sumner WA.
// Use this component freely.
// This is my way of giving back to the programming community.
// I'd welcome any comments or suggestions for improvements you may have,
// and if you find this component useful, drop me a note.
// Most of all, Enjoy. . .
//
//---------------------------------------------------------------------------
// History
// 4/17/97	New
// 5/05/97	Added font resizing
// 5/06/97	Placed fudge factor into code.(see note)
//
// NOTE:Windows(or BCB) doent not move components mathematically between large
//      and small fonts. I have found components off upto 12 pixels from what a
//		true ratio says they are.  These little annoyances add up to a
//		possibility of the form showing scroll bars going from developed in large
//		to run on small fonts.  Will continue to look at this.
#include <vcl\vcl.h>
#pragma hdrstop

#include "Jresfix.h"
//---------------------------------------------------------------------------
static inline TJResFix *ValidCtrCheck()
{
	return new TJResFix(NULL);
}
//---------------------------------------------------------------------------
__fastcall TJResFix::TJResFix(TComponent* Owner)
	: TComponent(Owner)
{
    FScaled = false;
    FDesRes = 96;
    FFont = dmSmallFont;
}
//---------------------------------------------------------------------------
void __fastcall TJResFix::SetRes(TDesFont res)
{
	FFont = res;
    if (res == dmSmallFont)
    	FDesRes = 96;
    else
		FDesRes = 120;
}
//---------------------------------------------------------------------------
void TJResFix::FixRes(void)
{
int i, j;
long ThisRes, TmpVal;
String test;
TButton *button;
//TFont 	*font;
TClass	ClassRef;
	if(FScaled == true)
    	return;
    FScaled = true;
    ThisRes = Screen->PixelsPerInch;
    TForm* frm = dynamic_cast<TForm *>(Owner);
    frm->PixelsPerInch = ThisRes;
// The following are fudge factors that appear to work best.  May be modified
// at a later date.
    if(frm->PixelsPerInch != FDesRes) {
		if(FDesRes == 120)
        	FDesRes =  115;
        else
        	FDesRes = 95;
		for(i=0; i < frm->ComponentCount; i++) {
			if(frm->Components[i]->InheritsFrom(__classid(TControl))) {
                button = (TButton *)frm->Components[i];
				for(j=0; j < 4; j++) {
                	switch(j) {
                    	case 0: TmpVal = button->Top; break;
                    	case 1: TmpVal = button->Left; break;
                    	case 2: TmpVal = button->Height; break;
                    	case 3: TmpVal = button->Width; break;
                    }
                    TmpVal = (TmpVal*FDesRes)/ThisRes;
                  	switch(j) {
                    	case 0: button->Top = TmpVal; break;
                    	case 1: button->Left = TmpVal; break;
                    	case 2: button->Height = TmpVal; break;
                    	case 3: button->Width = TmpVal; break;
                    }
              	}
				button->Font->Size = (button->Font->Size*FDesRes)/ThisRes;
// Fudging here as 7 point or less on a small font machine looks like '@#$%'
                if(button->Font->Size < 8)
                	button->Font->Size++;
            }
        }
    }

}

//---------------------------------------------------------------------------
namespace Jresfix
{
	void __fastcall Register()
	{
		TComponentClass classes[1] = {__classid(TJResFix)};
		RegisterComponents("Jason", classes, 0);
	}
}
//---------------------------------------------------------------------------
