/* _pipe example */
#include <windows.h>   //for SECURITY_ATTRIBUTES
#include <stdlib.h>
#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <process.h>

void main(int argc, char *argv[])
{
    //int handles[2];      ******* old stuff
    int retcode, stat, pid;
    char asc_handle[10];
    SECURITY_ATTRIBUTES sa;
    HANDLE s_hFileMap;

    if (argc > 1)   /* this is the child */
    {
        /* Get the read pipe handle from command line,
         * and set the handle to binary.
         */
        printf("Child: The handle passed as 2nd argument is: %s\n", argv[1]);
        s_hFileMap = (HANDLE) atoi(argv[1]);


        //handles[0] = atoi(argv[1]);              ********* old stuff
        //setmode(handles[0],O_TEXT);

        /* Read the desired return code from pipe

         */
        //if (read(handles[0], &retcode, sizeof(retcode)) < 0)

        LPVOID lpView = MapViewOfFile(s_hFileMap,
                                      FILE_MAP_READ|FILE_MAP_WRITE,
                                      0,0,0);
        if (lpView == NULL) 
        {
            perror("Child: unable to read pipe");
            retcode = 255;
        }

        //printf("Child: returning %d to parent\n",retcode);
        printf("Child: returning %s to parent\n",lpView);
        
        retcode = atoi((char*) lpView);
        UnmapViewOfFile(lpView);
        CloseHandle(s_hFileMap);       //Child is responsible for this
        exit(retcode);
    }
    else            /* this is the parent */
    {
        /* Open a pipe, convert read handle number to ASCII.
         * Write a value to the pipe that the child process
         * will use as its return code.

         */ 
        //  ********* We're going to use memory mapped files instead ******
        //
        //if (_pipe(handles,256,O_TEXT) == -1)
        //{
        //    perror("Parent: unable to create pipe");
        //    exit(1);
        //}
        
        //Here we set up the security attributes of the file mapping object
        //so that we can inherit it from the child process.  Alternatively
        //and more cheaply, we could use just the name of the mapping object
        //once inside the child process and call OpenFileMapping with that 
        //name.
        sa.nLength = sizeof(sa);
        sa.lpSecurityDescriptor = NULL;
        sa.bInheritHandle = TRUE;
        
        s_hFileMap = CreateFileMapping((HANDLE) 0xFFFFFFFF,//in memory
                                       &sa,                //security attrib
                                       PAGE_READWRITE,
                                       0,                  //min. size 
                                       256,                //size
                                       NULL);              //give mapping object no name

        LPVOID lpView = MapViewOfFile(s_hFileMap,
                                      FILE_MAP_READ|FILE_MAP_WRITE,
                                      0,0,0);
        if (lpView == NULL)
        {
            perror("Parent: unable to create file mapping");
            exit(1);
        }

        //sprintf(asc_handle,"%d",handles[0]);  ***** old stuff
        //if (write(handles[1],&retcode,sizeof(retcode)) < 0) ***** old stuff

        sprintf(asc_handle,"%d",s_hFileMap);
        retcode = 10;
        if (sprintf((char*)lpView,"%d",retcode) == EOF)
        {
            perror("Parent: unable to write to pipe");
            exit(1);
        }

        /* Call ourself with read handle as argument.
         */
        if ((pid = spawnl(P_NOWAIT, argv[0], argv[0], 
                          asc_handle, NULL)) == -1)
            perror("Parent: spawnl failed");
        else
        {
            printf("Parent: spawned child process %d\n",pid);
            if (wait(&stat) != pid)
                perror("Parent: wait failure");
            else
            {
                if ((stat & 0xff) == 0)
                    printf("Parent: child returned %d\n", stat >> 8);
                else
                    printf("Parent: child terminated abnormally\n");

            }
        }
        //close(handles[0]);  ******** old stuff
        //close(handles[1]);
       
        UnmapViewOfFile(lpView);
        CloseHandle(s_hFileMap);       
        exit(0);
    }
}

