//---------------------------------------------------------------------------
// ScanBox v1.0
//
// This is a C++Builder component
// by Ylian Saint-Hilaire
// http://kairos.dsa.uqam.ca/software
//
// K2000 Scanning
//---------------------------------------------------------------------------
#ifndef ScanBoxH
#define ScanBoxH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
//---------------------------------------------------------------------------
class TScanBox : public TCustomControl
{
private:
	MESSAGE void __fastcall WMTimer(TWMTimer &Message);
    TColor *ColorTable;

protected:
    bool ping;
    TTimer *Timer;
    TColor Color1;
	TColor Color2;
   	unsigned int mark;
	unsigned int delay;
   	unsigned int zones;
   	unsigned int fade;
    TNotifyEvent FOnPing;
    TNotifyEvent FOnPong;
    __fastcall void Paint(void);
	__fastcall void DoPaint(void);
	__fastcall void setColor1(TColor C);
	__fastcall void setColor2(TColor C);
    __fastcall void setFade (unsigned int V);
	__fastcall void setDelay(unsigned int D);
   	__fastcall void setZones(unsigned int V);
	__fastcall void TimerExpired(TObject *Sender);

public:
	__fastcall TScanBox(TComponent* Owner);
	__fastcall ~TScanBox();

__published:
	__property TColor FgColor       ={read=Color1 , write=setColor1};
	__property TColor BkColor       ={read=Color2 , write=setColor2};
	__property unsigned int Fade	={read=fade   , write=setFade  };
	__property unsigned int Delay   ={read=delay  , write=setDelay };
	__property unsigned int Zones	={read=zones  , write=setZones };
   	__property TNotifyEvent OnPing  ={read=FOnPing, write=FOnPing};
   	__property TNotifyEvent OnPong  ={read=FOnPong, write=FOnPong};

};
//---------------------------------------------------------------------------
#endif
