//---------------------------------------------------------------------------
//
//   TAnsiStringTokenizer header file ( Do not edit )
//	  1997 Kenneth Kestner
//
//---------------------------------------------------------------------------
#ifndef TAnsiStringTokenizerH
#define TAnsiStringTokenizerH
#include <vcl/dstring.h>
#include <stdio.h>
#include <string.h>
#include <vcl/classes.hpp>

//---------------------------------------------------------------------------
class TAnsiStringTokenizer
{
	public:
    	//Constructor
		TAnsiStringTokenizer( 	const AnsiString& value,
    							AnsiString delimiters=", ",
                                bool allowEmptyTokens=false,
                                bool trimSpaces = true);
    	//Destructor
        ~TAnsiStringTokenizer();

        //return number of tokens
		unsigned int GetTokenCount();

        //get token at specified index
    	AnsiString GetToken( unsigned int index );

        //same as GetToken
        AnsiString operator[](unsigned int index);

        // false indicates the constructor failed
    	bool IsValid();

        // returns integer value of a token
        int GetIntValue( unsigned int index );


    private:
    	bool m_Valid;
        TStringList* m_Tokens;
};

#endif
