//(c) Jon Jenkinson 1997

//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include <dos.h>

#include "Unit2.h"
#include "Unit1.h"
//---------------------------------------------------------------------------
//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall LineChecker::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------
__fastcall LineChecker::LineChecker(bool CreateSuspended)
	: TThread(CreateSuspended)
{
//Note::
//This is the Constructor.  Actual constructor code should really
//go into the execute function.
}
//---------------------------------------------------------------------------
void __fastcall LineChecker::Execute()
{

HANDLE ReturnedHandle;//File handle required locally

//---- Place thread code here ----

//Be pedantic.  You should really Set in use semaphore to 
//check if we try and run twice at the same time.


do   //Unbreakable from here,  only released via main app(see last while)
{

	//=****Actual Line checking

	do	//While file is open by another user, (i.e. modem in use)
        {
		ReturnedHandle = CreateFile(//As per Win32 help !
   				"COM2",
				GENERIC_READ | GENERIC_WRITE,
				0,
				NULL,
				OPEN_EXISTING,
				FILE_FLAG_SEQUENTIAL_SCAN,
				NULL);
	        IsActive = true;//turn the local online semaphore flag on
		Synchronize(UpdateLEDDisplay);//Change LED State
        }while(ReturnedHandle == INVALID_HANDLE_VALUE);

        //line is free,  so we've opened it by ourselves,  
	//we must close it to allow other programs access
	if(CloseHandle(ReturnedHandle))
		{
		//Application->MessageBox("Line Clear","MB",MB_OK);
                IsActive = false;//turn the local online flag off
		Synchronize(UpdateLEDDisplay);//turn the LED off
                sleep(1);//let someone else have access
		}
	else
		{//This should never happen,  but then again
	 Application->MessageBox("Line Error,  Open already","MB",MB_OK);
		}

	//=*****End of actual line checking


}while(Terminated == false);//Application has terminated

FreeOnTerminate = true; //being pedantic
Terminate();		//being very pedantic
}
//---------------------------------------------------------------------------

void __fastcall LineChecker::UpdateLEDDisplay()
{//Set the state of the LED on form1 based on local semaphore
	switch(IsActive)
    	{
        case true://turn LED on
        	Form1->OnLine->Visible = true;
	        Form1->OffLine->Visible = false;
        	Form1->OnOff = true;
	        break;
        case false://turn LED off
        	Form1->OnLine->Visible = false;
        	Form1->OffLine->Visible = true;
	        Form1->OnOff = false;
        	break;
        default://ignore: This should be impossible,  but we really 
		//should check
        	break;
        }
}


