//---------------------------------------------------------------------------
#include <vcl\sharemem.hpp>
#include <vcl\vcl.h>
#include <vcl\exptintf.hpp>
#pragma hdrstop

#include "main.h"
#include "generate.h"
//---------------------------------------------------------------------------
//   Important note about DLL memory management:
//
//   If your DLL exports any functions that pass String objects (or structs/
//   classes containing nested Strings) as parameter or function results,
//   you will need to add the library BCBMM.LIB to both the DLL project and any
//   EXE projects that use the DLL.  This will change the DLL and its calling
//   EXE's to use the BCBMM.DLL as their memory manager.  In these cases,
//   the file BCBMM.DLL should be deployed along with your DLL.
//
//   To avoid using BCBMM.DLL, pass string information using "char *" or
//   ShortString parameters.
//---------------------------------------------------------------------------
USERES("expwiz.res");
USELIB("Bcbmm.lib");
USEFORM("main.cpp", FormMainWizard);
USEUNIT("generate.cpp");
USEFORM("targetdir.cpp", FormOpenDirectory);
USEFORM("menuselection.cpp", FormMenuSelection);
//---------------------------------------------------------------------------
TExpertState tx;
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
	return 1;
}
//---------------------------------------------------------------------------
class __declspec(delphiclass) DCExpertWizard;

class DCExpertWizard : public TIExpert
{
public:
	System::AnsiString __stdcall GetName(void);
	System::AnsiString __stdcall GetAuthor(void);
	System::AnsiString __stdcall GetComment(void);
	System::AnsiString __stdcall GetPage(void);
	HICON __stdcall GetGlyph(void);
	TExpertStyle __stdcall GetStyle(void);
	TExpertState __stdcall GetState(void);
	System::AnsiString __stdcall GetIDString(void);
    System::AnsiString __stdcall GetMenuText(void){};
	void __stdcall Execute(void);

	__fastcall DCExpertWizard(void){};
	__fastcall virtual ~DCExpertWizard(void){};

};
//---------------------------------------------------------------------------
void
HandleException(void)
{

}
//---------------------------------------------------------------------------
System::AnsiString
__stdcall DCExpertWizard::GetName(void)
{
	try
    {
		return "ExpertWizard";
    }
    catch(...)
    {
		HandleException();
    }
}
//---------------------------------------------------------------------------
System::AnsiString
__stdcall DCExpertWizard::GetAuthor(void)
{
	try
    {
		return "Daniel Carey";
    }
    catch(...)
    {
		HandleException();
    }
}
//---------------------------------------------------------------------------
System::AnsiString
__stdcall DCExpertWizard::GetComment(void)
{
	try
    {
		return "This expert aids in the creation of other experts.";
    }
    catch(...)
    {
		HandleException();
    }
}
//---------------------------------------------------------------------------
System::AnsiString
__stdcall DCExpertWizard::GetPage(void)
{
	try
    {
    	return "Projects";
    }
    catch(...)
    {
		HandleException();
    }
}
//---------------------------------------------------------------------------
HICON __stdcall
DCExpertWizard::GetGlyph(void)
{
	try
    {
		return NULL;
    }
    catch(...)
    {
		HandleException();
    }
}
//---------------------------------------------------------------------------
TExpertStyle
__stdcall DCExpertWizard::GetStyle(void)
{
	try
    {
		return esProject;
    }
    catch(...)
    {
		HandleException();
    }
}
//---------------------------------------------------------------------------
TExpertState
__stdcall DCExpertWizard::GetState(void)
{
	try
    {
    	tx << esEnabled;
		return tx;
    }
    catch(...)
    {
		HandleException();
    }
}
//---------------------------------------------------------------------------
System::AnsiString
__stdcall DCExpertWizard::GetIDString(void)
{
	try
    {
		return "DanielCarey.ExpertWizard";
    }
    catch(...)
    {
		HandleException();
    }
}
//---------------------------------------------------------------------------
void
__stdcall DCExpertWizard::Execute(void)
{
	TFormMainWizard* frm;
	try
    {
	frm = new TFormMainWizard(Application );

    if( frm->ShowModal() == mrOk )
    {
		Generator gen(frm);
        gen.Generate();
    }
    frm->Free();

    }
    catch(...)
    {
		HandleException();
    }
}
//---------------------------------------------------------------------------
void
__fastcall DoneExpert(void)
{
}
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport)
bool
__stdcall INITEXPERT0016(	Toolintf::TIToolServices* ToolServices,
							TExpertRegisterProc	RegisterProc,
                            TExpertTerminateProc &Terminate)
{
  // make sure we"re the first and only instance
  int Result = Exptintf::ToolServices == NULL;
  if (!Result) return false;

  Exptintf::ToolServices = ToolServices;
  if (ToolServices != NULL)
    Application->Handle = ToolServices->GetParentHandle();
  else
    return false;

  Terminate = DoneExpert;

  // register the experts
  DCExpertWizard *ew = new DCExpertWizard;
  (*RegisterProc)(ew);

  return true;
}
//---------------------------------------------------------------------------

