/*
	The following information basically outlines the order
    the ouput stream should look like and the associated method.

	Out file Area Name				Method Name

    headerinfo						Header()
      included applications
    startup information				Startup()
    class header					ClassDef()
    exception handler               Exception()
    method declaration				Methods()
    	handler                  		MethodGetName()
										MethodGetAuthor()
                                        MethodGetComment()
                                        MethodGetPage()
                                        MethodGetGlyph()
                                        MethodGetStyle()
                                        MethodGetState()
                                        MethodGetIDString()
                                        MethodGetName();
                                        MethodGetMenuText()
                                        MethodExecute()
    donexpert                       Done
    entrypoint (forms,proj,std)		Entry

*/

//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl/classes.hpp>
#pragma hdrstop

#include "generate.h"

#define CR AnsiString("\r\n")
#define STR AnsiString


//---------------------------------------------------------------------------
Generator::Generator( TFormMainWizard* w)
{
	try
    {
		fwizard = w;
    }
    catch(...)
    {

    }
}
//---------------------------------------------------------------------------
Generator::~Generator(void)
{
	try
    {
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void
Generator::Seperator(void)
{
	try
    {
    	str = "//---------------------------------------------------------------------------" + CR;

        SourceStream->WriteBuffer( str.c_str(), str.Length() );
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void
Generator::Header(void)
{
	try
    {
    	Seperator();

		str = "// Expert Generated by Daniel Carey's Wizard Expert" + CR;
        str += "//---------------------------------------------------------------------------" + CR;
		str += "#include <vcl\\sharemem.hpp>" + CR;
		str += "#include <vcl\\vcl.h>" + CR;
		str += "#include <vcl\\exptintf.hpp>" + CR;

		if( (fwizard->do_mGenerateForm == true ) || (fwizard->do_mGenerateApplication == true) )
        {
			str += "#include \"" + fwizard->AppUnitName + ".h\"" + CR;
        }
		str += "#pragma hdrstop" + CR + CR;

		str += "//---------------------------------------------------------------------------" + CR;
		str += "//   Important note about DLL memory management:" + CR;
		str += "//" + CR;
		str += "//   If your DLL exports any functions that pass String objects (or structs/" + CR;
		str += "//   classes containing nested Strings) as parameter or function results," + CR;
		str += "//   you will need to add the library BCBMM.LIB to both the DLL project and any" + CR;
		str += "//   EXE projects that use the DLL.  This will change the DLL and its calling" + CR;
		str += "//   EXE's to use the BCBMM.DLL as their memory manager.  In these cases," + CR;
		str += "//   the file BCBMM.DLL should be deployed along with your DLL." + CR;
		str += "//" + CR;
		str += "//   To avoid using BCBMM.DLL, pass string information using \"char *\" or" + CR;
		str += "//   ShortString parameters." + CR;
		str += "//---------------------------------------------------------------------------" + CR;
		str += "USERES(\"" + STR( fwizard->Name ) + STR(".res\");") + CR; // **************COME BACK TO THIS ONE
		str += "USELIB(\"Bcbmm.lib\");" + CR;
		str += "//---------------------------------------------------------------------------" + CR;
		str += "TExpertState tx;" + CR;
		str += "//---------------------------------------------------------------------------" + CR;
		str += "int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)" + CR;
		str += "{" + CR;
		str += "	return 1;" + CR;
		str += "}" + CR;

        SourceStream->WriteBuffer( str.c_str(), str.Length() );
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void
Generator::Startup(void)
{
	try
    {
    	Seperator();

    	if( (fwizard->do_mGenerateForm == true) || (fwizard->do_mGenerateApplication == true) )
        {
        	str = "";
        	str += "T" + fwizard->AppFormName + STR( "* frm;" ) + CR;
        	SourceStream->WriteBuffer( str.c_str(), str.Length() );
        }
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void
Generator::ClassDef(void)
{
	try
    {
    	Seperator();
        
		str = "class __declspec(delphiclass) " + STR( fwizard->Name ) + STR( ";" ) + CR + CR;

        str += "class " + STR( fwizard->Name ) + STR( " : public TIExpert" ) + CR;
        str += "{" + CR;
        str += "public:" + CR;
		str += "	System::AnsiString __stdcall GetName(void);			//Short, descriptive name" + CR;

        if( fwizard->do_mGetAuthor == true )
			str += "	System::AnsiString __stdcall GetAuthor(void);		//Expert's Author" + CR;
        else
        	str += "	System::AnsiString __stdcall GetAuthor(void){};		//not needed for this expert" + CR;

		if( fwizard->do_mGetComment == true )
			str += "	System::AnsiString __stdcall GetComment(void);		//More complete description" + CR;
        else
        	str += "	System::AnsiString __stdcall GetComment(void){};	//not needed for this expert" + CR;

		if( fwizard->do_mGetPage == true )
			str += "	System::AnsiString __stdcall GetPage(void);			//Object repository page" + CR;
        else
        	str += "	System::AnsiString __stdcall GetPage(void){};		//not needed for this expert" + CR;

		if( fwizard->do_mGetGlyph == true )
			str += "	HICON __stdcall GetGlyph(void);						//Icon" + CR;
        else
        	str += "	HICON __stdcall GetGlyph(void){};					//not needed for this expert" + CR;

		str += "	TExpertStyle __stdcall GetStyle(void);				//Expert style, Form,Project,Standard,Add-in" + CR;

        if( fwizard->do_mGetState == true )
			str += "	TExpertState __stdcall GetState(void);				//Menu state" + CR;
        else
        	str += "	TExpertState __stdcall GetState(void){};			//not needed for this expert" + CR;

		str += "	System::AnsiString __stdcall GetIDString(void);		//Unique, internal identifier" + CR;

        if( fwizard->do_mGetMenuText == true )
			str += "    System::AnsiString __stdcall GetMenuText(void); 	//Menu Label" + CR;
        else
        	str += "    System::AnsiString __stdcall GetMenuText(void){}; 	//note needed for this expert" + CR;

		if( fwizard->do_mExecute == true )
			str += "	void __stdcall Execute(void);						//Run the expert" + CR + CR;
        else
        	str += "	void __stdcall Execute(void){};						//not needed for this expert" + CR + CR;

		str += "	__fastcall " + STR( fwizard->Name ) + STR("(void){};") + CR;
		str += "	__fastcall virtual ~" + STR( fwizard->Name ) + STR( "(void){};" ) + CR;

        str += "};" + CR;

        SourceStream->WriteBuffer( str.c_str(), str.Length() );
	}
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void
Generator::Exception(void)
{
	try
    {
    	Seperator();
        
		str = "void" + CR;
		str += "HandleException(void)" + CR;
		str += "{" + CR + CR;

		str += "}" + CR;

        SourceStream->WriteBuffer( str.c_str(), str.Length() );
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void
Generator::Methods(void)
{
	try
    {
    	MethodGetName();	// these are required by all experts
        MethodGetStyle();
        MethodGetIDString();

        if( fwizard->do_mGetAuthor == true )
        	MethodGetAuthor();

		if( fwizard->do_mGetComment == true )
        	MethodGetComment();

		if( fwizard->do_mGetPage == true )
        	MethodGetPage();

		if( fwizard->do_mGetGlyph == true )
        	MethodGetGlyph();

        if( fwizard->do_mGetState == true )
        	MethodGetState();

        if( fwizard->do_mGetMenuText == true )
        	MethodGetMenuText();

		if( fwizard->do_mExecute == true )
        	MethodExecute();

    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void
Generator::Done(void)
{
	try
    {
    	Seperator();
        
		str = "void" + CR;
    	str +="__fastcall DoneExpert(void)" + CR;
		str +="{" + CR;
    	str +="}" + CR;

		SourceStream->WriteBuffer( str.c_str(), str.Length() );
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void
Generator::Entry(void)
{
	try
    {
    	Seperator();

		str = "";
		str += "extern \"C\" __declspec(dllexport)" + CR;
		str += "bool" + CR;
		str += "__stdcall INITEXPERT0016(	Toolintf::TIToolServices* ToolServices," + CR;
		str += "							TExpertRegisterProc	RegisterProc," + CR;
		str += "                            TExpertTerminateProc &Terminate)" + CR;
		str += "{" + CR;
		str += "	// make sure we're the first and only instance" + CR;
		str += "	int Result = Exptintf::ToolServices == NULL;" + CR;
		str += "	if (!Result) return false;" + CR + CR;

		str += "	Exptintf::ToolServices = ToolServices;" + CR;
		str += "	if (ToolServices != NULL)" + CR;
		str += "		Application->Handle = ToolServices->GetParentHandle();" + CR;
		str += "	else" + CR;
		str += "		return false;" + CR + CR;

		str += "	Terminate = DoneExpert;" + CR + CR;

		str += "	// register the experts" + CR;
        str += "	" + fwizard->Name + STR(" *ew = new ") + fwizard->Name + STR(";") + CR;
		str += "	(*RegisterProc)(ew);" + CR + CR;

        if( (fwizard->provide_menu_code == true) &&
        	(fwizard->Style == esAddIn) )
        {
        	str += "	AddMenuItem();" + CR + CR;
        }

		str += "	return true;" + CR;
        str += "}" + CR;

        SourceStream->WriteBuffer( str.c_str(), str.Length() );
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void
Generator::MethodGetName(void)
{
	try
    {
    	Seperator();

		str = "";

		str += "System::AnsiString" + CR;
		str += "__stdcall " + STR(fwizard->Name) + STR( "::GetName(void)" ) + CR;
		str += "{" + CR;
		str += "	try" + CR;
		str += "    {" + CR;
		str += "		return \"" + STR(fwizard->Name) + STR("\";") + CR;
		str += "    }" + CR;
		str += "    catch(...)" + CR;
		str += "    {" + CR;
		str += "		HandleException();" + CR;
		str += "    }" + CR;
        str += "}" + CR;

        SourceStream->WriteBuffer( str.c_str(), str.Length() );
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void
Generator::MethodGetAuthor(void)
{
	try
    {
    	Seperator();

		str = "";

		str += "System::AnsiString" + CR;
		str += "__stdcall " + STR(fwizard->Name) + STR( "::GetAuthor(void)" ) + CR;
		str += "{" + CR;
		str += "	try" + CR;
		str += "    {" + CR;
		str += "		return \"" + STR(fwizard->Author) + STR("\";") + CR;
		str += "    }" + CR;
		str += "    catch(...)" + CR;
		str += "    {" + CR;
		str += "		HandleException();" + CR;
		str += "    }" + CR;
        str += "}" + CR;

        SourceStream->WriteBuffer( str.c_str(), str.Length() );
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void
Generator::MethodGetComment(void)
{
	try
    {
    	Seperator();

		str = "";

		str += "System::AnsiString" + CR;
		str += "__stdcall " + STR(fwizard->Name) + STR( "::GetComment(void)" ) + CR;
		str += "{" + CR;
		str += "	try" + CR;
		str += "    {" + CR;
		str += "		return \"" + STR(fwizard->Comment) + STR("\";") + CR;
		str += "    }" + CR;
		str += "    catch(...)" + CR;
		str += "    {" + CR;
		str += "		HandleException();" + CR;
		str += "    }" + CR;
        str += "}" + CR;

        SourceStream->WriteBuffer( str.c_str(), str.Length() );
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void
Generator::MethodGetPage(void)
{
	try
    {
    	Seperator();

		str = "";

		str += "System::AnsiString" + CR;
		str += "__stdcall " + STR(fwizard->Name) + STR( "::GetPage(void)" ) + CR;
		str += "{" + CR;
		str += "	try" + CR;
		str += "    {" + CR;
		str += "		return \"" + STR(fwizard->Page) + STR("\";") + CR;
		str += "    }" + CR;
		str += "    catch(...)" + CR;
		str += "    {" + CR;
		str += "		HandleException();" + CR;
		str += "    }" + CR;
        str += "}" + CR;

        SourceStream->WriteBuffer( str.c_str(), str.Length() );
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void
Generator::MethodGetGlyph(void)
{
	try
    {
    	Seperator();

		str = "";

		str += "HICON" + CR;
		str += "__stdcall " + STR(fwizard->Name) + STR( "::GetGlyph(void)" ) + CR;
		str += "{" + CR;
		str += "	try" + CR;
		str += "    {" + CR;
		str += "		return NULL;		// this must be replaced with IConic Information" + CR;
		str += "    }" + CR;
		str += "    catch(...)" + CR;
		str += "    {" + CR;
		str += "		HandleException();" + CR;
		str += "    }" + CR;
        str += "}" + CR;

        SourceStream->WriteBuffer( str.c_str(), str.Length() );
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void
Generator::MethodGetStyle(void)
{
	try
    {
    	Seperator();

		str = "";

		str += "TExpertStyle" + CR;
		str += "__stdcall " + STR(fwizard->Name) + STR( "::GetStyle(void)" ) + CR;
		str += "{" + CR;
		str += "	try" + CR;
		str += "    {" + CR;

		str += "		return ";
        if( fwizard->Style == esForm )
        	str += "esForm;" + CR;
        if( fwizard->Style == esProject )
        	str += "esProject;" + CR;
        if( fwizard->Style == esStandard )
        	str += "esStandard;" + CR;
        if( fwizard->Style == esAddIn )
        	str += "esAddIn;" + CR;

		str += "    }" + CR;
		str += "    catch(...)" + CR;
		str += "    {" + CR;
		str += "		HandleException();" + CR;
		str += "    }" + CR;
        str += "}" + CR;

        SourceStream->WriteBuffer( str.c_str(), str.Length() );
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void
Generator::MethodGetState(void)
{
	try
    {
    	Seperator();

		str = "";

		str += "TExpertState" + CR;
		str += "__stdcall " + STR(fwizard->Name) + STR( "::GetState(void)" ) + CR;
		str += "{" + CR;
		str += "	try" + CR;
		str += "    {" + CR;

		str += "		tx";
        if( fwizard->MenuTextEnabled == true )
        	str += " << esEnabled";
        if( fwizard->MenuTextChecked == true )
        	str += " << esChecked";
        str += ";" + CR;

        str += "		return tx;" + CR;
		str += "    }" + CR;
		str += "    catch(...)" + CR;
		str += "    {" + CR;
		str += "		HandleException();" + CR;
		str += "    }" + CR;
        str += "}" + CR;

        SourceStream->WriteBuffer( str.c_str(), str.Length() );
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void
Generator::MethodGetIDString(void)
{
	try
    {
    	Seperator();

		str = "";

		str += "System::AnsiString" + CR;
		str += "__stdcall " + STR(fwizard->Name) + STR( "::GetIDString(void)" ) + CR;
		str += "{" + CR;
		str += "	try" + CR;
		str += "    {" + CR;
		str += "		return \"" + STR(fwizard->IDString) + STR("\";") + CR;
		str += "    }" + CR;
		str += "    catch(...)" + CR;
		str += "    {" + CR;
		str += "		HandleException();" + CR;
		str += "    }" + CR;
        str += "}" + CR;

        SourceStream->WriteBuffer( str.c_str(), str.Length() );
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void
Generator::MethodGetMenuText(void)
{
	try
    {
    	Seperator();

		str = "";

		str += "System::AnsiString" + CR;
		str += "__stdcall " + STR(fwizard->Name) + STR( "::GetMenuText(void)" ) + CR;
		str += "{" + CR;
		str += "	try" + CR;
		str += "    {" + CR;
		str += "		return \"" + STR(fwizard->MenuText) + STR("\";") + CR;
		str += "    }" + CR;
		str += "    catch(...)" + CR;
		str += "    {" + CR;
		str += "		HandleException();" + CR;
		str += "    }" + CR;
        str += "}" + CR;

        SourceStream->WriteBuffer( str.c_str(), str.Length() );
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void
Generator::MethodExecute(void)
{
	try
    {
    	str = "";

        str += "void" + CR;
        str += "__stdcall " + STR(fwizard->Name) + STR( "::Execute(void)" ) + CR;
        str += "{" + CR;
        str += "	try" + CR;
        str += "	{" + CR;
        str += "        RunExpert( 0L );" + CR;
        str += "	}" + CR;
        str += "	catch(...)" + CR;
        str += "	{" + CR;
        str += "	}" + CR;
        str += 	"}" + CR;

        SourceStream->WriteBuffer( str.c_str(), str.Length() );
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void
Generator::Generate(void)
{
	AnsiString sfile;
	TCreateModuleFlags mf;

    try
    {
        sfile = fwizard->prjdir + STR( "\\" ) + fwizard->Name + STR(".cpp");
		SourceStream = new TFileStream( sfile.c_str(), fmCreate );

		Header();

        Startup();

        ClassDef();

        Exception();

        RunExpert();

        Methods();

        Done();

        if( (fwizard->provide_menu_code == true) &&
        	(fwizard->Style == esAddIn) )
			AddMenuItem();

        Entry();

        delete SourceStream;

		MakeProject();
		if( (fwizard->do_mGenerateForm == true) || (fwizard->do_mGenerateApplication == true) )
			MakeApplication();

    }
    catch(...)
    {

    }
}
//---------------------------------------------------------------------------
void
Generator::MakeProject(void)
{
    TFileStream* MFile;
    TMemoryStream* MemStream;
    AnsiString filename;

    try
    {
    	MemStream = new TMemoryStream;

		filename = fwizard->prjdir + STR( "\\" ) + fwizard->Name + STR( ".mak" );

	    MFile = new TFileStream( filename.c_str(), fmCreate );


		str = "";


		str += "# ---------------------------------------------------------------------------" + CR;
		str += "VERSION = BCB.01" + CR;
		str += "# ---------------------------------------------------------------------------" + CR;
		str += "!ifndef BCB" + CR;
		str += "BCB = $(MAKEDIR)\.." + CR;
		str += "!endif" + CR;
		str += "# ---------------------------------------------------------------------------" + CR;
        str += "PROJECT = " + fwizard->Name + STR( ".dll" ) + CR;
		str += "OBJFILES = " + fwizard->Name + STR( ".obj " ) + CR;
        str += "RESFILES = " + fwizard->Name + STR( ".res" ) + CR;
        str += "RESDEPEN = $(RESFILES) " + CR;
		str += "LIBFILES = Bcbmm.lib" + CR;
		str += "DEFFILE =" + CR;
		str += "# ---------------------------------------------------------------------------" + CR;
		str += "CFLAG1 = -WD -Od -Hc -w -k -r- -y -v -vi- -c -a4 -b- -w-par -w-inl -Vx -Ve -x" + CR;
		str += "CFLAG2 = -I$(BCB)\\objrepos;$(BCB)\\projects;$(BCB)\\include;$(BCB)\\include\\vcl \\" + CR;
		str += "   -H=$(BCB)\\lib\\vcld.csm" + CR;
		str += "PFLAGS = -U$(BCB)\\objrepos;$(BCB)\\projects;$(BCB)\\lib\\obj;$(BCB)\\lib \\" + CR;
		str += "   -I$(BCB)\\objrepos;$(BCB)\\projects;$(BCB)\\include;$(BCB)\\include\\vcl \\" + CR;
		str += "   -AWinTypes=Windows;WinProcs=Windows;DbiTypes=BDE;DbiProcs=BDE;DbiErrs=BDE -v \\" + CR;
		str += "   -$Y -$W -$O- -JPHNV -M" + CR;
		str += "RFLAGS = -i$(BCB)\\objrepos;$(BCB)\\projects;$(BCB)\\include;$(BCB)\\include\\vcl" + CR;
		str += "LFLAGS = -L$(BCB)\\objrepos;$(BCB)\\projects;$(BCB)\\lib\\obj;$(BCB)\\lib -Tpd -aa \\" + CR;
		str += "   -x -v -V4.0" + CR;
		str += "IFLAGS =" + CR;
		str += "LINKER = ilink32" + CR;
		str += "# ---------------------------------------------------------------------------" + CR;
		str += "ALLOBJ = c0d32.obj $(OBJFILES)" + CR;
		str += "ALLRES = $(RESFILES)" + CR;
		str += "ALLLIB = $(LIBFILES) vcl.lib import32.lib cp32mt.lib" + CR;
		str += "# ---------------------------------------------------------------------------" + CR;
		str += ".autodepend" + CR + CR;

		str += "$(PROJECT): $(OBJFILES) $(RESDEPEN) $(DEFFILE)" + CR;
		str += "    $(BCB)\BIN\$(LINKER) @&&!" + CR;
		str += "    $(LFLAGS) +" + CR;
		str += "    $(ALLOBJ), +" + CR;
		str += "    $(PROJECT),, +" + CR;
		str += "    $(ALLLIB), +" + CR;
		str += "    $(DEFFILE), +" + CR;
		str += "    $(ALLRES)" + CR;
		str += "!" + CR + CR;

		str += ".pas.hpp:" + CR;
		str += "    $(BCB)\\BIN\\dcc32 $(PFLAGS) { $** }" + CR + CR;

		str += ".pas.obj:" + CR;
		str += "    $(BCB)\\BIN\\dcc32 $(PFLAGS) { $** }" + CR + CR;

		str += ".cpp.obj:" + CR;
		str += "    $(BCB)\\BIN\\bcc32 $(CFLAG1) $(CFLAG2) -o$* $*" + CR + CR;

		str += ".c.obj:" + CR;
		str += "    $(BCB)\\BIN\\bcc32 $(CFLAG1) $(CFLAG2) -o$* $**" + CR + CR;

		str += ".rc.res:" + CR;
		str += "    $(BCB)\\BIN\\brcc32 $(RFLAGS) $<" + CR;
		str += "#-----------------------------------------------------------------------------" + CR;


        MemStream->WriteBuffer( str.c_str(), str.Length() );
        MemStream->Seek( 0, soFromBeginning ); // rewind stream before writing
        MFile->CopyFrom( MemStream, 0 );

        delete MemStream;
    	delete MFile;

        ToolServices->OpenProject( filename );

        return;
    }
    catch(...)
    {
    }

}
//---------------------------------------------------------------------------
void
Generator::RunExpert(void)
{
	try
    {
    	Seperator();

		str = "";

		str += "void" + CR;
		str += "__stdcall RunExpert( TIMenuItemIntf* )" + CR;
		str += "{" + CR;

		if( fwizard->do_mGenerateApplication == true ) // write an Execute for a dialog
        {
			str += "	try" + CR;
			str += "    {" + CR;
            str += "		if( !frm )" + CR;
            str += "		{" + CR;
			str += "			frm = new T" + fwizard->AppFormName + STR( "(Application);" ) + CR;
            str += "		}" + CR + CR;
	        str += "		frm->Show();" + CR;
	        str += "	}" + CR;
	        str += "	catch(...)" + CR;
	        str += "	{" + CR;
	        str += "		HandleException();" + CR;
	        str += "	}" + CR;

        } else if ( fwizard->do_mGenerateForm == true ) // write an Execute for a non-dialog
        {
			str += "	try" + CR;
			str += "    {" + CR;
			str += "		frm = new T" + fwizard->AppFormName + STR( "(Application);" ) + CR + CR;
	        str += "		if( frm->ShowModal() )" + CR;
	        str += "		{" + CR;
	        str += "			// insert action on success here" + CR;
	        str += "		}" + CR;
	        str += "		frm->Free();" + CR;
	        str += "	}" + CR;
	        str += "	catch(...)" + CR;
	        str += "	{" + CR;
	        str += "		HandleException();" + CR;
	        str += "	}" + CR;

        }else	// write an ::Execute that is commented
        {
        	str += "/*" + CR;
			str += "	try" + CR;
			str += "    {" + CR;
			str += "		frm = new T" + fwizard->AppFormName + STR( "(Application);" ) + CR + CR;
	        str += "		if( frm->ShowModal() )" + CR;
	        str += "		{" + CR;
	        str += "			// insert action on success here" + CR;
	        str += "		}" + CR;
	        str += "		frm->Free();" + CR;
	        str += "	}" + CR;
	        str += "	catch(...)" + CR;
	        str += "	{" + CR;
	        str += "		HandleException();" + CR;
	        str += "	}" + CR;
	        str += "*/" + CR;
    	}
        str += "}" + CR;

        SourceStream->WriteBuffer( str.c_str(), str.Length() );
    }
    catch(...)
    {
    }

}
//---------------------------------------------------------------------------
void
Generator::AddMenuItem(void)
{
	try
    {
    	str = "";

		str += "void" + CR;
		str += "AddMenuItem(void)" + CR;
		str += "{" + CR;
        str += "	int index;" + CR;
		str += "	TIMainMenuIntf *mmi;" + CR;
		str += "    TIMenuItemIntf *miparent;" + CR;
        str += "	TIMenuItemIntf *michild;" + CR;
		str += "    TIMenuFlags mf;" + CR + CR;

		str += "    try" + CR;
		str += "    {" + CR;
		str += "    	mf << mfVisible";
        if( fwizard->MenuTextEnabled == true )
        	str += " << mfEnabled";
        if( fwizard->MenuTextChecked == true )
        	str += " << mfChecked";
        str += ";" + CR + CR;

		str += "		mmi = ToolServices->GetMainMenu();" + CR;
		str += "        michild = mmi->FindMenuItem( \"" + fwizard->MenuInsertPoint + STR( "\");" ) + CR + CR;

        str += "		index = michild->GetIndex();" + CR;
        str += "		index++;" + CR;
        str += "		miparent = michild->GetParent();" + CR + CR;

		str += "        miparent->InsertItem( index, \"" + fwizard->MenuText + STR( "\"," ) + CR;
		str += "                         \"" + fwizard->Name + STR("\",") + CR;
		str += "                         \"\", 0, 0, 0, mf, 0L );" + CR;
		str += "		michild->Release();" + CR;
		str += "		miparent->Release();" + CR;
		str += "        mmi->Release();" + CR;
		str += "    }" + CR;
		str += "    catch(...)" + CR;
		str += "    {" + CR;
		str += "    }" + CR;
		str += "}" + CR + CR;

        SourceStream->WriteBuffer( str.c_str(), str.Length() );
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void
Generator::MakeApplication(void)
{
    AnsiString appsourcefilename;
    try
    {
    	TCreateModuleFlags mf;

		mf << cmAddToProject << cmNewUnit << cmMarkModified;

        appsourcefilename = fwizard->prjdir + STR( "\\" ) + fwizard->AppUnitName + STR( ".cpp" );

		ToolServices->CreateCppModule( appsourcefilename,fwizard->AppFormName,
                        "","", 0L, 0L, 0L, mf );

		ToolServices->SaveProject();
		ToolServices->OpenFile( appsourcefilename );
        return;
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
