//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "main.h"
#include "targetdir.h"
#include "menuselection.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TFormMainWizard *FormMainWizard;
//---------------------------------------------------------------------------
__fastcall TFormMainWizard::TFormMainWizard(TComponent* Owner)
	: TForm(Owner)
{
	// what to generate
	do_mGetAuthor = true;
	do_mGetComment = true;
	do_mGetPage = true;
	do_mGetGlyph = true;
	do_mGetState = true;
    do_mGetMenuText = true;
	do_mExecute = true;

    do_mGenerateForm = false;
    do_mGenerateApplication = false;
    MenuInsertPoint = "ToolsGalleryItem";
    AppUnitName = "Unit1";
    AppFormName = "Form1";


	// how much comments to include
	very_verbose = true;
	provide_menu_code = true;

	// user supplied information
    MenuTextEnabled = true;
    MenuTextChecked = false;
    prjdir = "c:\\"; // project target directory

    Author = "ExpertWizard";
    Comment = "Automated expert generated by ExpertWizard";
    IDString = "OU812";
    MenuText = "ExpWiz";
    Name = "ExpWiz";
    Page = "Forms";
    Icon = NULL;
    State << esEnabled;
    Style = esForm;

    Edit4->Text = "c:\\";

}
//---------------------------------------------------------------------------
void __fastcall TFormMainWizard::ButtonCancelClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TFormMainWizard::ButtonPreviousClick(TObject *Sender)
{
	/*
    	0	TabSheetStart
        1	TabSheetCommon
        2	TabSheetFormProject
        3	TabSheetStandard
        4	TabSheetGenOptions
        5	TabSheetFinal
    */
	TTabSheet* tabsheet;
    try
    {
    	SetDataFromPage();
		tabsheet = PageControl1->ActivePage;

        if( tabsheet->Name == "TabSheetCommon" )
        {
        	PageControl1->ActivePage = PageControl1->Pages[0];
            ButtonPrevious->Enabled = false;

        }else if( (tabsheet->Name == "TabSheetFormProject") || (tabsheet->Name == "TabSheetStandard") )
        {
        	PageControl1->ActivePage = PageControl1->Pages[1];

        }else if( tabsheet->Name == "TabSheetGenOptions" )
        {
        	if( (Style == esAddIn)||(Style == esStandard) )
        		PageControl1->ActivePage = PageControl1->Pages[3];
            else
        		PageControl1->ActivePage = PageControl1->Pages[2];

        }else if( tabsheet->Name == "TabSheetFinal" )
        {
        	PageControl1->ActivePage = PageControl1->Pages[4];
            ButtonNext->Enabled = true;
        }

    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void __fastcall TFormMainWizard::ButtonNextClick(TObject *Sender)
{
	/*
    	0	TabSheetStart
        1	TabSheetCommon
        2	TabSheetFormProject
        3	TabSheetStandard
        4	TabSheetGenOptions
        5	TabSheetFinal
    */
	TTabSheet* tabsheet;
    try
    {
    	SetDataFromPage();

		tabsheet = PageControl1->ActivePage;

		if( tabsheet->Name == "TabSheetStart" )
        {
        	PageControl1->ActivePage = PageControl1->Pages[1];
        	ButtonPrevious->Enabled = true;

        }else if( tabsheet->Name == "TabSheetCommon" )
        {
        	if( (Style == esAddIn) || (Style == esStandard) )
        		PageControl1->ActivePage = PageControl1->Pages[3];
            else
        		PageControl1->ActivePage = PageControl1->Pages[2];

        }else if( (tabsheet->Name == "TabSheetFormProject") || (tabsheet->Name == "TabSheetStandard") )
        {
        	PageControl1->ActivePage = PageControl1->Pages[4];

        }else if( tabsheet->Name == "TabSheetGenOptions" )
        {
        	PageControl1->ActivePage = PageControl1->Pages[5];
            ButtonNext->Enabled = false;

        }

    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void __fastcall TFormMainWizard::FormActivate(TObject *Sender)
{
    Edit7->Text = Name;
    Edit6->Text = IDString;

    Edit1->Text = Author;
    Edit2->Text = Comment;
    ComboBox1->Text = Page;

    Edit3->Text = MenuText;
    Edit5->Text = MenuInsertPoint;
    CheckBox2->Checked = MenuTextEnabled;
    CheckBox3->Checked = MenuTextChecked;
    CheckBox4->Checked = provide_menu_code;

    Edit8->Text = AppUnitName;
    Edit9->Text = AppFormName;

	if( do_mGenerateForm == true )
    {
    	if( RadioButton6->OnClick )
			RadioButton6->OnClick;
    }else if( do_mGenerateApplication == true )
    {
    	if( RadioButton7->OnClick )
    		RadioButton7->OnClick;
    }else
    {
    	if( RadioButton5->OnClick )
			RadioButton5->OnClick;
    }
	FillRepositoryList();
}
//---------------------------------------------------------------------------
void
TFormMainWizard::SetDataFromPage(void)
{
	/*
    	0	TabSheetStart
        1	TabSheetCommon
        2	TabSheetFormProject
        3	TabSheetStandard
        4	TabSheetGenOptions
        5	TabSheetFinal
    */
	TTabSheet* tabsheet;
    try
    {

		tabsheet = PageControl1->ActivePage;

		if( tabsheet->Name == "TabSheetStart" )
        {
			if( RadioButton1->Checked == true )
            {
    			Style = esForm;
                do_mGetAuthor = true;
				do_mGetComment = true;
				do_mGetPage = true;
				do_mGetGlyph = true;
				do_mGetState = false;
    			do_mGetMenuText = false;
				do_mExecute = true;
            }

			if( RadioButton2->Checked == true )
            {
    			Style = esProject;
                do_mGetAuthor = true;
				do_mGetComment = true;
				do_mGetPage = true;
				do_mGetGlyph = true;
				do_mGetState = false;
    			do_mGetMenuText = false;
				do_mExecute = true;
            }

    		if( RadioButton3->Checked == true )
            {
    			Style = esStandard;
                do_mGetAuthor = false;
				do_mGetComment = false;
				do_mGetPage = false;
				do_mGetGlyph = false;
				do_mGetState = true;
    			do_mGetMenuText = true;
				do_mExecute = true;
                //disable the ability to select menu location and menu generation routine
                Edit5->Enabled = false;
                Button3->Enabled = false;
                CheckBox4->Enabled = false;

            }

    		if( RadioButton4->Checked == true )
            {
    			Style = esAddIn;
                do_mGetAuthor = false;
				do_mGetComment = false;
				do_mGetPage = false;
				do_mGetGlyph = false;
				do_mGetState = false;
    			do_mGetMenuText = false;
				do_mExecute = false;
                //enable the ability to select menu location
                Edit5->Enabled = true;
                Button3->Enabled = true;
                CheckBox4->Enabled = true;
            }

        }else if( tabsheet->Name == "TabSheetCommon" )
        {
            Name = Edit7->Text;
    		IDString = Edit6->Text;
            prjdir = Edit4->Text;

        }else if( tabsheet->Name == "TabSheetFormProject")
    	{
    		Author = Edit1->Text;
    		Comment = Edit2->Text;
    		Page = ComboBox1->Text;

        }else if( tabsheet->Name == "TabSheetStandard" )
        {
    		MenuText = Edit3->Text;
            MenuInsertPoint = Edit5->Text;
    		MenuTextEnabled = CheckBox2->Checked;
    		MenuTextChecked = CheckBox3->Checked;
            provide_menu_code = CheckBox4->Checked;

        }else if( tabsheet->Name == "TabSheetGenOptions" )
        {
            AppUnitName = Edit8->Text;
    		AppFormName = Edit9->Text;

            if( RadioButton6->Checked == true )
            	do_mGenerateForm = true;
            else
            	do_mGenerateForm = false;

            if( RadioButton7->Checked == true )
            	do_mGenerateApplication = true;
            else
            	do_mGenerateApplication = false;

        }else if( tabsheet->Name == "TabSheetFinal" )
        {
        }

    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void __fastcall TFormMainWizard::Button2Click(TObject *Sender)
{
	TFormOpenDirectory *fod;
	try
    {
    	fod = new TFormOpenDirectory( this );

        fod->DirectoryListBox1->Directory = prjdir;

        if( fod->Execute() == mrOk )
        {
        	fod->DirectoryListBox1->OpenCurrent();
			Edit4->Text = fod->DirectoryListBox1->Directory;
        }

        delete fod;
    }

    catch(...)
    {

    }
}
//---------------------------------------------------------------------------
void __fastcall TFormMainWizard::Button3Click(TObject *Sender)
{
	TFormMenuSelection* fms;
    try
    {
		fms = new TFormMenuSelection(this);

        if( fms->ShowModal() == mrOk )
        {
            Edit5->Text = fms->MenuSelect;
        }
        delete fms;

    }
    catch(...)
    {

    }
}
//---------------------------------------------------------------------------
void
TFormMainWizard::FillRepositoryList(void)
{
    try
    {
    	ComboBox1->Items->Clear();

        ComboBox1->Items->Add( "New" );
        ComboBox1->Items->Add( "Forms" );
        ComboBox1->Items->Add( "Dialogs" );
        ComboBox1->Items->Add( "Data Modules" );
        ComboBox1->Items->Add( "Projects" );
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------
void __fastcall TFormMainWizard::RadioButton5Click(TObject *Sender)
{
	Edit8->Enabled = false;
    Edit9->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TFormMainWizard::RadioButton6Click(TObject *Sender)
{
	Edit8->Enabled = true;
    Edit9->Enabled = true;

}
//---------------------------------------------------------------------------
